/*
 * Login Controller
 */ 
app.controller('LoginController', ['$http', '$window', '$location',
                                   function ($http, $window, $location) {
      
    var ctrl = this;
    ctrl.username = '';
    ctrl.password = '';

    /**
     * Authenticate user.
     * @function submit
     * @memberof loginController
     */
    ctrl.login = function() {
        // POST data to API
        $http({
            method : 'POST',
            url : '/api/auth',
            data : {
                'username' : ctrl.username,
                'password' : ctrl.password,
            }
        }).then(function(response) {
            // Login success
            $window.location.href = '/';
        }, function(response) {
            // Login error
            ctrl.error = response.data;
            ctrl.alert_danger = true;
        });
    };

    ctrl.logout = function() {
        // DELETE authentication session identifier
        $http.delete('/api/auth').then(function(response) {
            // Redirect to login
            $window.location.href = '/login';
        });
    };
    
    ctrl.getUser = function() {
        $http({
            method: 'GET',
            url: '/api/user'
        }).then(function(response) {
            // First function handles success
            ctrl.user = response.data;
            ctrl.user.isAdmin = ctrl.user.privilege_level == "admin";
        }, function(response) {
            // Second function handles error
        });
    };
    
}]);
